## pgrouting 3.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2 FATAL_ERROR)

if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR "In-source builds not allowed.
    Please make a new directory (called a build directory) and run CMake from there.
    You may need to remove CMakeCache.txt." )
endif()

#---------------------------------------------
# Setting kind of build
#---------------------------------------------

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(pgr/BuildType)


#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

project(PGROUTING VERSION 3.3.0
    LANGUAGES C CXX )
set(PROJECT_VERSION_DEV "")
string(TOLOWER "${PROJECT_NAME}" PROJECT_NAME_LOWER)

include(pgr/GitInfo)
include(pgr/Version)

add_definitions(-DPROJECT_VERSION="${PROJECT_VERSION}${PROJECT_VERSION_DEV}")
set(PROJECT_LIB_NAME "${PROJECT_NAME_LOWER}-${PROJECT_LIB_VERSION}")

string(TIMESTAMP COMPILATION_DATE "%Y/%m/%d")

set(MINORS 3.3 3.2 3.1 3.0 2.6)
set(OLD_SIGNATURES
    3.2.2 3.2.1 3.2.0
    3.1.4 3.1.3 3.1.2 3.1.1 3.1.0
    3.0.6 3.0.5 3.0.4 3.0.3 3.0.2 3.0.1 3.0.0
    2.6.3 2.6.2 2.6.1 2.6.0
    )



#=============================================
# Set the working directories
#=============================================
include(pgr/Configure)


#---------------------------------------------
# minimum versions
#---------------------------------------------
set(DOXYGEN_MINIMUM_VERSION "1.7")
set(SPHINX_MINIMUM_VERSION "4.0")
set(POSTGRESQL_MINIMUM_VERSION "9.2.0")
set(BOOST_MINIMUM_VERSION "1.56.0")
set(POSTGIS_MINIMUM_VERSION "2.0.0")

message(STATUS "DOXYGEN_MINIMUM_VERSION=${DOXYGEN_MINIMUM_VERSION}")
message(STATUS "SPHINX_MINIMUM_VERSION=${SPHINX_MINIMUM_VERSION}")
message(STATUS "POSTGRESQL_MINIMUM_VERSION=${POSTGRESQL_MINIMUM_VERSION}")
message(STATUS "BOOST_MINIMUM_VERSION=${BOOST_MINIMUM_VERSION}")
message(STATUS "POSTGIS_MINIMUM_VERSION=${POSTGIS_MINIMUM_VERSION}")

# cmake 3.2 adds unwanted flags
if(WIN32 AND MSVC)
    set(CMAKE_C_FLAGS "")
    set(CMAKE_CXX_FLAGS "")
endif()

#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
# C/C++ Compiler requirements
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------

find_package(Boost ${BOOST_MINIMUM_VERSION} REQUIRED)
if (NOT Boost_VERSION_MACRO)
    set(Boost_VERSION_MACRO ${Boost_VERSION})
endif()
add_definitions(-DBoost_VERSION_MACRO=${Boost_VERSION_MACRO})
set(BOOST_VERSION "${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION}")

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
if (BOOST_VERSION VERSION_LESS "1.75.0")
    CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
    if(COMPILER_SUPPORTS_CXX11)
        set(CMAKE_CXX_STANDARD 11)
        set(CMAKE_CXX_STANDARD_REQUIRED ON)
        set(CMAKE_CXX_EXTENSIONS OFF)
    else()
        CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
        if(COMPILER_SUPPORTS_CXX0X)
            add_compile_options("-std=c++0x")
            message(STATUS "Using  -std=c++0x.")
        else()
        message(WARNING "The compiler ${CMAKE_CXX_COMPILER} has no C++0x or C++11 flags support.
            Using: callback compiler's standard")
        endif()
    endif()
else()
    set(CMAKE_CXX_STANDARD 14)
endif()

add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)
set(COMPILER_VERSION "${CMAKE_CXX_COMPILER_ID}-${CMAKE_CXX_COMPILER_VERSION}")


#---------------------------------------------
# Windows compiler flags
#---------------------------------------------


if(WIN32 AND NOT MSVC)
    set(OS_BUILD  $ENV{OS_BUILD})
    if(NOT OS_BUILD)
        set(OS_BUILD "64")
    endif()
    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH}:/c/ming${OS_BUILD}/projects/pgx${OS_BUILD}/pg92)
    if (NOT BOOST_ROOT)
        set(BOOST_ROOT c:/ming${OS_BUILD}/msys/local)
    endif()

    if (PROJECT_DEBUG)
        message(STATUS "OS_BUILD=${OS_BUILD}")
        message(STATUS "BOOST_ROOT=${BOOST_ROOT}")
        message(STATUS "CMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}")
    endif()
endif(WIN32 AND NOT MSVC)

if(WIN32 AND MSVC)
    add_compile_options(
        -D_CRT_SECURE_NO_DEPRECATE
        -D_SCL_SECURE_NO_DEPRECATE
        -D_CRT_SECURE_NO_WARNINGS
        -D_SCL_SECURE_NO_WARNINGS
        -D_CRT_NONSTDC_NO_DEPRECATE
        -D_CRT_NONSTDC_NO_DEPRECATE
        -EHsc)
endif()

#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
# Finding prerequisites
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------

#---------------------------------------------
#---------------------------------------------
# Perl
#---------------------------------------------
#---------------------------------------------
include(FindPerl)
if(NOT PERL_EXECUTABLE)
    message(FATAL_ERROR "perl NOT FOUND - Please check your Perl installation.")
endif()

#---------------------------------------------
#---------------------------------------------
# PostgreSQL
#---------------------------------------------
#---------------------------------------------
find_package(PostgreSQL)
if(NOT POSTGRESQL_FOUND OR NOT POSTGRESQL_VERSION_STRING)
    message(FATAL_ERROR "PostgreSQL not found - Please check your PostgreSQL installation.")
endif()

message(STATUS "POSTGRESQL_VERSION_STRING=${POSTGRESQL_VERSION_STRING}")
string(SUBSTRING "${POSTGRESQL_VERSION_STRING}" 11 -1 POSTGRESQL_VERSION)

# for XbetaY XalphaY XrcY -> X.Y
string(REGEX REPLACE "^([0-9]+)[beta|alpha|rc|devel].*" "\\1.0" POSTGRESQL_VERSION ${POSTGRESQL_VERSION})

#for X.Y.Z -> XY  Y<10
string(REGEX REPLACE "^([0-9]+)\\.([0-9]+).*" "\\1\\2" PGSQL_VERSION ${POSTGRESQL_VERSION})


if("${POSTGRESQL_VERSION}" VERSION_LESS "${POSTGRESQL_MINIMUM_VERSION}")
    message(FATAL_ERROR " PostgreSQL ${POSTGRESQL_MINIMUM_VERSION} or greater is required.")
endif("${POSTGRESQL_VERSION}" VERSION_LESS "${POSTGRESQL_MINIMUM_VERSION}")

#-------
include_directories(SYSTEM ${POSTGRESQL_INCLUDE_DIR})
if(WIN32)
    include_directories(SYSTEM ${POSTGRESQL_INCLUDE_DIR}/port/win32)
    if(MSVC)
        include_directories(SYSTEM ${POSTGRESQL_INCLUDE_DIR}/port/win32_msvc/)
    endif()
endif()

add_definitions(-DPGSQL_VERSION=${PGSQL_VERSION})
message(STATUS "PGSQL_VERSION=${PGSQL_VERSION}")


#---------------------------------------------
#---------------------------------------------
# Boost
#---------------------------------------------
#---------------------------------------------

include_directories(SYSTEM ${Boost_INCLUDE_DIRS})


#---------------------------------------------
if (PROJECT_DEBUG)
    message(STATUS "PERL_VERSION_STRING = ${PERL_VERSION_STRING}")
    message(STATUS "POSTGRESQL_VERSION is ${PGSQL_VERSION}")
    message(STATUS "PGSQL_VERSION is ${PGSQL_VERSION}")
    message(STATUS "Boost_INCLUDE_DIRS = ${Boost_INCLUDE_DIRS}")
    message(STATUS "POSTGRESQL_INCLUDE_DIR = ${POSTGRESQL_INCLUDE_DIR}")
endif()


#---------------------------------------------
#---------------------------------------------
# PROJECT includes
#---------------------------------------------
#---------------------------------------------
include_directories(${PROJECT_SOURCE_DIR}/include)

#---------------------------------------------
# library directory
#---------------------------------------------
execute_process(
    COMMAND ${POSTGRESQL_PG_CONFIG} --pkglibdir
    OUTPUT_STRIP_TRAILING_WHITESPACE
    OUTPUT_VARIABLE LIBRARY_INSTALL_PATH)

if(NOT LIBRARY_INSTALL_PATH)
    message(FATAL_ERROR "pg_config --pkglibdir failed to return a value. Please check your PostgreSQL installation!")
endif()

message(STATUS "LIBRARY_INSTALL_PATH ${LIBRARY_INSTALL_PATH}")

#---------------------------------------------
# extension directory
#---------------------------------------------

execute_process(
    COMMAND ${POSTGRESQL_PG_CONFIG} --sharedir
    OUTPUT_STRIP_TRAILING_WHITESPACE
    OUTPUT_VARIABLE SHARE_DIR)

#-------
if(SHARE_DIR)
    set(SHARE_DIR "${SHARE_DIR}/extension")
else(SHARE_DIR)
    message(FATAL_ERROR "pg_config --sharedir failed to return a value. Please check your PostgreSQL installation!")
endif(SHARE_DIR)

#---------------------------------------------

if (PROJECT_DEBUG)
    message(STATUS "POSTGRESQL_LIBRARIES=${POSTGRESQL_LIBRARIES}")
    message(STATUS "LIBRARY_INSTALL_PATH=${LIBRARY_INSTALL_PATH}")
    message(STATUS "SHARE_DIR=${SHARE_DIR}")
endif()



#---------------------------------------------
# Special cases for windows
#---------------------------------------------

if(WIN32)
    link_directories(${POSTGRESQL_LIBRARIES})
    link_libraries(postgres)
endif()

#-----------------------------------------------------------------------------

if (PROJECT_DEBUG)
    get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
    message(STATUS "INCLUDE_DIRECTORIES='${dirs}'")
endif()


#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#compiler directives
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# https://www.postgresql.org/docs/10/xfunc-c.html

if(NOT WIN32)
    CHECK_C_COMPILER_FLAG("-fPIC" C_COMPILER_SUPPORTS_FPIC)
    CHECK_CXX_COMPILER_FLAG("-fPIC" CXX_COMPILER_SUPPORTS_FPIC)
    if(C_COMPILER_SUPPORTS_FPIC)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC ")
    endif()
    if(CXX_COMPILER_SUPPORTS_FPIC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC ")
    endif()
endif()

if(WIN32 AND MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_C_FLAGS}")
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        CHECK_C_COMPILER_FLAG("-frounding-math" C_COMPILER_SUPPORTS_ROUNDING_MATH)
        CHECK_CXX_COMPILER_FLAG("-frounding-math" CXX_COMPILER_SUPPORTS_ROUNDING_MATH)
        if(C_COMPILER_SUPPORTS_ROUNDING_MATH)
            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -frounding-math ")
        endif()
        if(CXX_COMPILER_SUPPORTS_ROUNDING_MATH)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -frounding-math ")
        endif()
    endif()

    set(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS_DEBUG}   -Wall -Wconversion -Wmissing-prototypes -W -Wunused -Wuninitialized -Wextra -Wdouble-promotion")
    add_definitions(-Wsign-conversion  -Wfloat-conversion)
    if(BOOST_Geometry_VERSION_OK)
        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wconversion -pedantic -W -Wunused -Wuninitialized -Wextra -Wdouble-promotion")
    else()
        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -pedantic -W -Wunused -Wuninitialized -Wextra -Wdouble-promotion")
    endif()
endif()



#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

if (PROJECT_DEBUG)
    message(STATUS "CMAKE_CXX_FLAGS_DEBUG= ${CMAKE_CXX_FLAGS_DEBUG}")
    message(STATUS "CMAKE_CXX_FLAGS_RELEASE= ${CMAKE_CXX_FLAGS_RELEASE}")
    message(STATUS "CMAKE_CXX_FLAGS= ${CMAKE_CXX_FLAGS}")

    message(STATUS "CMAKE_C_FLAGS_DEBUG= ${CMAKE_C_FLAGS_DEBUG}")
    message(STATUS "CMAKE_C_FLAGS_RELEASE= ${CMAKE_C_FLAGS_RELEASE}")
    message(STATUS "CMAKE_C_FLAGS= ${CMAKE_C_FLAGS}")

    message(STATUS "UNIX=${UNIX}")
    message(STATUS "WIN32=${WIN32}")
    message(STATUS "MSVC=${MSVC}")
endif()

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


#====================================================================
# Include the working directories
#====================================================================

=== requirements.txt ===
Sphinx>4.0.0
sphinx-bootstrap-theme>=0.8.0

=== doc/CMakeLists.txt ===
#
# Find Sphinx
# Find Sphinx executable to build documentation
# Source: https://ericscottbarr.com/blog/2012/03/sphinx-and-cmake-beautiful-documentation-for-c-projects/
#
# Daniel Kastl 03/2013
#

#---------------------------------------------
# Kind of sphinx output
#---------------------------------------------

option(WITH_DOC
    "Set ON|OFF (default=OFF) to build Documentation library tree" OFF)

option(LOCALE
    "Set ON|OFF (default=OFF) to build ithe latest pot/po files" OFF)

option(WITH_ALL_DOC
    "Set ON|OFF (default=OFF) to build Documentation library tree" OFF)

#option(PDF
#    "Set ON|OFF (default=OFF) to build Documentation library tree as PDF" OFF)

option(BUILD_LATEX
    "Set ON|OFF (default=OFF) to build Documentation library tree as PDF" OFF)

option(SINGLEHTML
    "Set ON|OFF (default=OFF) to build Documentation library tree as SINGLE HTML" OFF)

option(BUILD_HTML
    "Set ON|OFF (default=OFF) to build Documentation library tree as HTML" ON)

option(BUILD_MAN
    "Set ON|OFF (default=OFF) to build Documentation library tree as MAN page" OFF)

option(LINKCHECK
    "Set ON|OFF (default=OFF) to build Documentation library tree as LINKCHECK page" OFF)

option(EPUB
    "Set ON|OFF (default=OFF) to build Documentation library tree as EPUB page" OFF)

option(DUMMY
    "Set ON|OFF (default=OFF) for debugging purposes" OFF)

if (LOCALE)
    set(WITH_DOC ON)
endif()

if (NOT WITH_DOC)
    return()
endif()

foreach(opt BUILD_HTML BUILD_LATEX BUILD_MAN SINGLEHTML EPUB DUMMY LINKCHECK)
    if (${${opt}} OR WITH_ALL_DOC)
        string(TOLOWER ${opt} val)
        string(REPLACE "build_" "" val ${val})
        list(APPEND PROJECT_DOC_TARGETS ${val})
        set(WITH_DOC ON)
    endif()
endforeach()



message(STATUS "PROJECT_DOC_TARGETS = ${PROJECT_DOC_TARGETS}")

#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

# LANGUAGES SETINGS

#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

#---------------------------------------------
# Available Languages
# English is always built
#---------------------------------------------
set(PROJECT_SUPPORTED_LANGUAGES  "de"   "es"  "fr"  "it"  "ja"  "ru")
set(PROJECT_ENGLISH "en")

#---------------------------------------------
# Language options
#---------------------------------------------
option(WITH_ALL_LANG
    "Set ON|OFF (default=OFF) to build all the supported languages:
    Main Language will always be built:
    ${PROJECT_ENGLISH}
    Optional languages:
    ${PROJECT_SUPPORTED_LANGUAGES}

    When OFF and want to build specific optional language, use the language code in capital letters:
    -D ES=ON
    "
    OFF
    )

foreach(lang ${PROJECT_SUPPORTED_LANGUAGES})
    string(TOUPPER ${lang} val)
    option(${val}
        "Set ON|OFF (default=OFF) build ${lang} Documentation" OFF)
endforeach()

#---------------------------------------------
# Catching the language options to be build
#---------------------------------------------
foreach(lang ${PROJECT_SUPPORTED_LANGUAGES})
    string(TOUPPER ${lang} opt)
    if (${opt} OR WITH_ALL_LANG)
        set (langFound  "1")
        list(APPEND PROJECT_BUILD_LANGUAGES ${lang})
    endif()
endforeach()


#---------------------------------------------
# All languages po files are to be generated
#---------------------------------------------

set (SPHINXINTL_LANGUAGE  ${PROJECT_ENGLISH})
foreach(lang ${PROJECT_BUILD_LANGUAGES})
    set(SPHINXINTL_LANGUAGE "${SPHINXINTL_LANGUAGE},${lang}")
endforeach()


list(APPEND PROJECT_BUILD_LANGUAGES  ${PROJECT_ENGLISH})
message(STATUS "PROJECT_BUILD_LANGUAGES = ${PROJECT_BUILD_LANGUAGES}")
message(STATUS "SPHINXINTL_LANGUAGE = ${SPHINXINTL_LANGUAGE}")


if(NOT WITH_DOC)
    return()
endif()


#---------------------------------------------
# Checking for prerequisites
#---------------------------------------------
find_package(Sphinx ${SPHINX_MINIMUM_VERSION} REQUIRED)

if (NOT SPHINX_FOUND)
    message(FATAL_ERROR "Sphinx not found.
    Cannot generate documentation!
    Install Sphinx or build without documentation")
endif()

if (SPHINX_VERSION VERSION_LESS 1.0)
    message(WARNING "Your Sphinx version is too old!
    This project requires Sphinx v${SPHINX_MINIMUM_VERSION} or above to produce
    proper documentation (you have v${SPHINX_VERSION}).
    You will get output but it will have errors.")
endif()

#pip install rst2pdf



#---------------------------------------------
# Kind of "looks"
#---------------------------------------------
option(DOC_USE_BOOTSTRAP
    "Set ON|OFF (default=ON) to build Documentation library tree as MAN page" OFF)

if (DOC_USE_BOOTSTRAP)
    set(SPHINX_INCLUDE "import sphinx_bootstrap_theme")
    set(SPHINX_THEME "bootstrap")
    set(SPHINX_THEME_DIR "sphinx_bootstrap_theme.get_html_theme_path()")
    set(SPHINX_THEME_OPTIONS "'source_link_position': \"none\",")
else()
    set(SPHINX_INCLUDE "")
    set(SPHINX_THEME "haiku")
    set(SPHINX_THEME_DIR "['']")
    set(SPHINX_THEME_OPTIONS "")
endif()




# configured documentation tools and intermediate build results
# TODO for 3.0 Use _build
# set(PGR_DOCUMENTATION_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/_build")
set(PGR_DOCUMENTATION_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}")
set(PGR_DOCUMENTATION_SOURCE_DIR "${CMAKE_CURRENT_BINARY_DIR}")

message(STATUS "PGR_DOCUMENTATION_BUILD_DIR = ${PGR_DOCUMENTATION_BUILD_DIR}")


#---------------------------------------------
# Adding documentation directories
#---------------------------------------------
foreach (subdir ${PROJECT_DOC_DIRECTORIES} "src")
    add_subdirectory("${subdir}")
    add_subdirectory("../docqueries/${subdir}" "build/doc/${subdir}")
endforeach()

add_subdirectory("images")


configure_file("../tools/testers/sampledata.sql" "${PGR_DOCUMENTATION_SOURCE_DIR}/sampledata/sampledata.sql")


#TODO ???
#add_subdirectory("static")
#add_subdirectory("themes")
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/_static" DESTINATION "${PGR_DOCUMENTATION_SOURCE_DIR}")
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/_themes" DESTINATION "${PGR_DOCUMENTATION_SOURCE_DIR}")


configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in"
    "${PGR_DOCUMENTATION_SOURCE_DIR}/conf.py"
    @ONLY)

# Add documentation to targets


#if (LATEX)
if (FALSE)
    find_package(LATEX)
    if (NOT LATEX_COMPILER)
        message("Couldn't find Latex, can't build latex docs using Sphinx")
    else()
        message(STATUS "LATEX_COMPILER = ${LATEX_COMPILER}")
    endif()
endif()

set(ENV{SPHINXINTL_LANGUAGE} ${SPHINXINTL_LANGUAGE})

if (LOCALE)
    add_custom_target(locale
        COMMAND ${SPHINX_EXECUTABLE}
        -b gettext
        -c "${PGR_DOCUMENTATION_SOURCE_DIR}"
        "${PGR_DOCUMENTATION_SOURCE_DIR}"
        "${CMAKE_SOURCE_DIR}/locale/pot"

        COMMAND sphinx-intl update -d ${CMAKE_SOURCE_DIR}/locale -l en > locale_changes.txt
    #COMMAND sphinx-intl update -p ${CMAKE_SOURCE_DIR}/locale/pot -d ${CMAKE_SOURCE_DIR}/locale --language=${SPHINXINTL_LANGUAGE}
    #COMMAND sphinx-intl update-txconfig-resources --locale-dir ${CMAKE_SOURCE_DIR}/locale --pot-dir ${CMAKE_SOURCE_DIR}/locale/pot --transifex-project-name pgrouting


    COMMENT "Generating POT files ..."
    SOURCES ${PROJECT_DOC_FILES}
    )
endif()


# The doc target will build all documentation targets.
add_custom_target(doc
    COMMENT "Building documentation with Sphinx")


foreach (target ${PROJECT_DOC_TARGETS})
    add_custom_target("${target}"
        COMMENT "Building ${target} documentation with Sphinx")

    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/forward.html"
        "${PGR_DOCUMENTATION_BUILD_DIR}/${target}/index.html")

    foreach (lang ${PROJECT_BUILD_LANGUAGES})
        add_custom_target(
            "${target}-${lang}"
            COMMAND ${SPHINX_EXECUTABLE}
            #-q  # Enable for quiet mode
            #-Q  # Enable for even more quiet mode
            -v   # increase verbosity
            -W
            --keep-going
            #-j auto
            #-E  # don't use a saved environment, always read all file
            #-a  # write all files; default is to only write new and changed files
            -b ${target}
            -D language='${lang}'
            -c "${PGR_DOCUMENTATION_SOURCE_DIR}"
            "${PGR_DOCUMENTATION_SOURCE_DIR}"
            "${PGR_DOCUMENTATION_BUILD_DIR}/${target}/${lang}"

            COMMENT "Generating ${target}/${lang} documentation ..."
            SOURCES ${PROJECT_DOC_FILES}  ${PROJECT_IMG_FILES}
            DEPENDS ${PROJECT_DOC_FILES}  ${PROJECT_IMG_FILES}
            )
        add_dependencies(${target} "${target}-${lang}")

    endforeach()
    add_dependencies(doc "${target}")
endforeach()



if(FALSE)
    # AND ${target} MATCHES "latex" AND LATEX_COMPILER)
    add_custom_target(pdf-${lang}
        COMMENT "Building documentation with Sphinx")

    add_custom_command(
        TARGET pdf-${lang} POST_BUILD
        #fixes: Underfull \hbox (badness 10000) in paragraph
        #perl -pi -e 's/warning/warning /' pgRoutingDocumentation.tex
        COMMAND pdflatex -interaction=nonstopmode "pgRoutingDocumentation.tex" > /dev/null 2>&1
        WORKING_DIRECTORY "${PGR_DOCUMENTATION_BUILD_DIR}/pdf/${lang}"
        DEPENDS ${target}-${lang}
        COMMENT "Converting Latex to PDF format")

endif()

=== doc/breadthFirstSearch/CMakeLists.txt ===

SET(LOCAL_FILES
    pgr_breadthFirstSearch.rst
    pgr_binaryBreadthFirstSearch.rst    
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/images/CMakeLists.txt ===

SET(LOCAL_FILES
    boost-inside.jpeg
    Fig1-originalData.png
    Fig2-cost.png
    Fig4-costUndirected.png
    Fig6-undirected.png
    parallelImage.png
    test1.png
    trsp-test-image.png
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${f}" COPYONLY)
    list(APPEND LOCAL_IMG_FILES  ${CMAKE_CURRENT_BINARY_DIR}/${f})
endforeach()

set(PROJECT_IMG_FILES ${PROJECT_IMG_FILES} ${LOCAL_IMG_FILES} PARENT_SCOPE)

=== doc/src/CMakeLists.txt ===

SET(LOCAL_FILES
    index.rst
    pgRouting-concepts.rst
    pgRouting-installation.rst
    pgRouting-introduction.rst
    proposed.rst
    experimental.rst
    release_notes.rst
    routingFunctions.rst
    sampledata.rst
    support.rst
    cost-category.rst
    costMatrix-category.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/topologicalSort/CMakeLists.txt ===

SET(LOCAL_FILES
    pgr_topologicalSort.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/traversal/CMakeLists.txt ===

SET(LOCAL_FILES
    traversal-family.rst
    pgr_depthFirstSearch.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

add_subdirectory("images")
set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)
set(PROJECT_IMG_FILES ${PROJECT_IMG_FILES} PARENT_SCOPE)

=== doc/vrp_basic/CMakeLists.txt ===

SET(LOCAL_FILES
    pgr_vrpOneDepot.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== docqueries/coloring/CMakeLists.txt ===
# Do not use extensions
SET(LOCAL_FILES
    doc-pgr_sequentialVertexColoring
    doc-bipartite
    doc-edgeColoring
    )

foreach (f ${LOCAL_FILES})
    configure_file("${f}.result" "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
    list(APPEND LOCAL_DOC_FILES  "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== docqueries/components/CMakeLists.txt ===
# Do not use extensions
SET(LOCAL_FILES
    doc-pgr_articulationPoints
    doc-pgr_biconnectedComponents
    doc-pgr_bridges
    doc-pgr_connectedComponents
    doc-pgr_strongComponents
    doc-pgr_makeConnected
    )

foreach (f ${LOCAL_FILES})
    configure_file("${f}.result" "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
    list(APPEND LOCAL_DOC_FILES  "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== docqueries/dagShortestPath/CMakeLists.txt ===
# Do not use extensions
SET(LOCAL_FILES
    doc-pgr_dagShortestPath
    )

foreach (f ${LOCAL_FILES})
    configure_file("${f}.result" "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
    list(APPEND LOCAL_DOC_FILES  "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== debian/changelog ===
pgrouting (3.3.0-2) unstable; urgency=medium

  * Team upload.
  * Allow building with sphinx < 4 for backports.

 -- Christoph Berg <myon@debian.org>  Thu, 17 Feb 2022 14:43:51 +0100

pgrouting (3.3.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 12 Nov 2021 18:51:42 +0100

pgrouting (3.2.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 23 Oct 2021 19:43:33 +0200

pgrouting (3.2.1-2) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 08 Oct 2021 14:45:48 +0200

pgrouting (3.2.1-2~exp1) experimental; urgency=medium

  * Team upload.

  [ Bas Couwenberg ]
  * Bump Standards-Version to 4.6.0, no changes.
  * Bump debhelper compat to 12, changes:
    - Drop --list-missing from dh_install
  * Update packaging for postgresql-14.

  [ Christoph Berg ]
  * Mark postgresql-*-pgrouting-{scripts,doc} as M-A: foreign.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 05 Oct 2021 21:54:51 +0200

pgrouting (3.2.1-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 15 Aug 2021 16:18:02 +0200

=== debian/control ===
Source: pgrouting
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Michael Fladischer <FladischerMichael@fladi.at>
Section: misc
Priority: optional
Build-Depends: cmake (>= 3.2),
               debhelper-compat (= 12),
               graphviz,
               libboost-graph-dev,
               libjs-mathjax,
               postgis,
               postgresql-server-dev-all,
               python3-sphinx (>= 1.8),
               rdfind,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/pgrouting
Vcs-Git: https://salsa.debian.org/debian-gis-team/pgrouting.git
Homepage: https://www.pgrouting.org

Package: postgresql-14-pgrouting
Architecture: any
Depends: postgresql-14-pgrouting-scripts (>= ${source:Version}),
         postgresql-14,
         postgresql-14-postgis,
         postgresql-14-postgis-scripts,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-14-pgrouting-doc
Provides: postgresql-pgrouting
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 14.

Package: postgresql-14-pgrouting-scripts
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: postgresql-pgrouting-scripts
Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the SQL scripts for installing pgRouting, and for
 upgrading from earlier pgRouting versions.
 .
 This package supports PostgreSQL 14.

Package: postgresql-14-pgrouting-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Don't fail when d/control doesn't match template
export PG_UPDATECONTROL=yes

CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

include /usr/share/postgresql-common/pgxs_debian_control.mk

%:
	dh $@ --with sphinxdoc

override_dh_auto_clean:
	+pg_buildext clean build-%v

override_dh_clean:
	dh_clean debian/postgresql-*-pgrouting.install \
	         debian/postgresql-*-pgrouting-scripts.install

override_dh_auto_configure:
	set -e; \
	for v in $$(pg_buildext supported-versions); do \
		cmake -H. -Bbuild-$$v -DWITH_DOC=ON -DPOSTGRESQL_PG_CONFIG=/usr/lib/postgresql/$$v/bin/pg_config -DCMAKE_VERBOSE_MAKEFILE=1; \
	done

override_dh_auto_build:
	+pg_buildext build build-%v
	set -e; \
	for v in $$(pg_buildext supported-versions); do \
		make -C build-$$v doc; \
		rm build-$$v/doc/html/en/_static/images/pgrouting.png; \
		ln -s ../pgrouting.png build-$$v/doc/html/en/_static/images/pgrouting.png; \
		rm build-$$v/doc/html/en/_static/images/ccbysa.png; \
		ln -s ../../_images/ccbysa.png build-$$v/doc/html/en/_static/images/ccbysa.png; \
		ln -s /usr/share/javascript/mathjax build-$$v/doc/html/en/_static/mathjax; \
	done

override_dh_auto_install:
	+pg_buildext install build-%v postgresql-%v-pgrouting
	set -e; \
	for v in $$(pg_buildext supported-versions); do \
		mkdir -p debian/postgresql-$$v-pgrouting-doc/usr/share/doc/postgresql-$$v-pgrouting-doc; \
		cp -r build-$$v/doc/html debian/postgresql-$$v-pgrouting-doc/usr/share/doc/postgresql-$$v-pgrouting-doc; \
		mkdir -p debian/postgresql-$$v-pgrouting-doc/usr/share/doc-base; \
		sed "s,PGVERSION,$$v,g" < debian/postgresql-pgrouting-doc.doc-base.in > debian/postgresql-$$v-pgrouting-doc/usr/share/doc-base/postgresql-$$v-pgrouting-doc; \
		mkdir -p debian/postgresql-$$v-pgrouting-scripts/usr; \
		mv debian/postgresql-$$v-pgrouting/usr/share debian/postgresql-$$v-pgrouting-scripts/usr; \
		rdfind -makeresultsfile false -makehardlinks true \
			debian/postgresql-$$v-pgrouting-scripts/usr/share/postgresql/*/extension; \
	done

override_dh_installchangelogs:
	dh_installchangelogs doc/src/release_notes.rst

override_dh_sphinxdoc-indep:
	dh_sphinxdoc -Xtheme_extras.js

override_dh_sphinxdoc-arch:

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/postgresql

## pgrouting 3.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 #---------------------------------------------
 #---------------------------------------------
 
-project(PGROUTING VERSION 3.3.0
+project(PGROUTING VERSION 3.3.1
     LANGUAGES C CXX )
 set(PROJECT_VERSION_DEV "")
 string(TOLOWER "${PROJECT_NAME}" PROJECT_NAME_LOWER)
@@ -33,6 +33,7 @@
 
 set(MINORS 3.3 3.2 3.1 3.0 2.6)
 set(OLD_SIGNATURES
+    3.3.0 
     3.2.2 3.2.1 3.2.0
     3.1.4 3.1.3 3.1.2 3.1.1 3.1.0
     3.0.6 3.0.5 3.0.4 3.0.3 3.0.2 3.0.1 3.0.0

=== doc/ksp/CMakeLists.txt ===

SET(LOCAL_FILES
     KSP-category.rst
     pgr_KSP.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== docqueries/breadthFirstSearch/CMakeLists.txt ===
# Do not use extensions
SET(LOCAL_FILES
    doc-pgr_breadthFirstSearch
    doc-pgr_binaryBreadthFirstSearch
    )

foreach (f ${LOCAL_FILES})
    configure_file("${f}.result" "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
    list(APPEND LOCAL_DOC_FILES  "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== docqueries/max_flow/CMakeLists.txt ===
# Do not use extensions
SET(LOCAL_FILES
    doc-pgr_boykovKolmogorov
    doc-pgr_edgeDisjointPaths
    doc-pgr_edmondsKarp
    doc-pgr_maxCardinalityMatch
    doc-pgr_maxFlow
    doc-pgr_pushRelabel
    doc-pgr_maxFlowMinCost
    doc-pgr_maxFlowMinCost_Cost

    )

foreach (f ${LOCAL_FILES})
    configure_file("${f}.result" "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
    list(APPEND LOCAL_DOC_FILES  "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}.queries")
endforeach()

set(PROJECT_DOC_FILES ${PROJECT_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== debian/changelog ===
pgrouting (3.3.1-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Fri, 08 Apr 2022 06:52:28 +0200

pgrouting (3.3.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file.
  * Refresh patches.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 08 Apr 2022 06:52:28 +0200

=== debian/control ===
--- 
+++ 
@@ -17,6 +17,70 @@
 Vcs-Git: https://salsa.debian.org/debian-gis-team/pgrouting.git
 Homepage: https://www.pgrouting.org
 
+Package: postgresql-10-pgrouting
+Architecture: any
+Depends: postgresql-10-pgrouting-scripts (>= ${source:Version}),
+         postgresql-10,
+         postgresql-10-postgis,
+         postgresql-10-postgis-scripts,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Suggests: postgresql-10-pgrouting-doc
+Provides: postgresql-pgrouting
+Description: Routing functionality support for PostgreSQL/PostGIS
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package supports PostgreSQL 10.
+
+Package: postgresql-11-pgrouting
+Architecture: any
+Depends: postgresql-11-pgrouting-scripts (>= ${source:Version}),
+         postgresql-11,
+         postgresql-11-postgis,
+         postgresql-11-postgis-scripts,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Suggests: postgresql-11-pgrouting-doc
+Provides: postgresql-pgrouting
+Description: Routing functionality support for PostgreSQL/PostGIS
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package supports PostgreSQL 11.
+
+Package: postgresql-12-pgrouting
+Architecture: any
+Depends: postgresql-12-pgrouting-scripts (>= ${source:Version}),
+         postgresql-12,
+         postgresql-12-postgis,
+         postgresql-12-postgis-scripts,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Suggests: postgresql-12-pgrouting-doc
+Provides: postgresql-pgrouting
+Description: Routing functionality support for PostgreSQL/PostGIS
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package supports PostgreSQL 12.
+
+Package: postgresql-13-pgrouting
+Architecture: any
+Depends: postgresql-13-pgrouting-scripts (>= ${source:Version}),
+         postgresql-13,
+         postgresql-13-postgis,
+         postgresql-13-postgis-scripts,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Suggests: postgresql-13-pgrouting-doc
+Provides: postgresql-pgrouting
+Description: Routing functionality support for PostgreSQL/PostGIS
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package supports PostgreSQL 13.
+
 Package: postgresql-14-pgrouting
 Architecture: any
 Depends: postgresql-14-pgrouting-scripts (>= ${source:Version}),
@@ -33,6 +97,62 @@
  .
  This package supports PostgreSQL 14.
 
+Package: postgresql-10-pgrouting-scripts
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Provides: postgresql-pgrouting-scripts
+Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package contains the SQL scripts for installing pgRouting, and for
+ upgrading from earlier pgRouting versions.
+ .
+ This package supports PostgreSQL 10.
+
+Package: postgresql-11-pgrouting-scripts
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Provides: postgresql-pgrouting-scripts
+Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package contains the SQL scripts for installing pgRouting, and for
+ upgrading from earlier pgRouting versions.
+ .
+ This package supports PostgreSQL 11.
+
+Package: postgresql-12-pgrouting-scripts
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Provides: postgresql-pgrouting-scripts
+Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package contains the SQL scripts for installing pgRouting, and for
+ upgrading from earlier pgRouting versions.
+ .
+ This package supports PostgreSQL 12.
+
+Package: postgresql-13-pgrouting-scripts
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Provides: postgresql-pgrouting-scripts
+Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package contains the SQL scripts for installing pgRouting, and for
+ upgrading from earlier pgRouting versions.
+ .
+ This package supports PostgreSQL 13.
+
 Package: postgresql-14-pgrouting-scripts
 Architecture: all
 Multi-Arch: foreign
@@ -47,6 +167,58 @@
  .
  This package supports PostgreSQL 14.
 
+Package: postgresql-10-pgrouting-doc
+Architecture: all
+Multi-Arch: foreign
+Section: doc
+Depends: libjs-mathjax,
+         ${misc:Depends},
+         ${sphinxdoc:Depends}
+Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package contains the documentation.
+
+Package: postgresql-11-pgrouting-doc
+Architecture: all
+Multi-Arch: foreign
+Section: doc
+Depends: libjs-mathjax,
+         ${misc:Depends},
+         ${sphinxdoc:Depends}
+Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package contains the documentation.
+
+Package: postgresql-12-pgrouting-doc
+Architecture: all
+Multi-Arch: foreign
+Section: doc
+Depends: libjs-mathjax,
+         ${misc:Depends},
+         ${sphinxdoc:Depends}
+Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package contains the documentation.
+
+Package: postgresql-13-pgrouting-doc
+Architecture: all
+Multi-Arch: foreign
+Section: doc
+Depends: libjs-mathjax,
+         ${misc:Depends},
+         ${sphinxdoc:Depends}
+Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
+ pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
+ geospatial routing and other network analysis functionality.
+ .
+ This package contains the documentation.
+
 Package: postgresql-14-pgrouting-doc
 Architecture: all
 Multi-Arch: foreign
